/*
 * lcd.c
 *
 *  Created on: 2017/11/25
 *      Author: yamada
 */

#include <stdint.h>
#include "type.h"
#include "gpio.h"
//#include "uart.h"
//#include "ssp.h"
#include "i2c.h"
#include "stdlib.h"
#include "mp3_11.h"

uint32_t lcd_init( unsigned char contrast)
{
	GPIOSetDir(PORT_I2C_LCD_RST, BIT_I2C_LCD_RST, 1 );

	GPIOSetBitValue( PORT_I2C_LCD_RST, BIT_I2C_LCD_RST, 0 );
	//wait_ms(10);
	//Delay();
	//delayMs(0, 10);
	WaitMs(10);
	GPIOSetBitValue( PORT_I2C_LCD_RST, BIT_I2C_LCD_RST, 1 );

	// ここからI2C LCDの初期化を行います。
	//wait_ms(40);
    //    Delay();
    //delayMs(0, 40);
        WaitMs(40);
	lcd_send_cmd(0x38);//0b00111000); // function set
	lcd_send_cmd(0x39);//0b00111001); // function set
	lcd_send_cmd(0x14);//0b00010100); // interval osc
	lcd_send_cmd(0x70 | (contrast & 0xF)); // contrast Low

	//lcd_send_cmd(0b01011100 | ((contrast >> 4) & 0x3)); // contast High/icon/power
	lcd_send_cmd(0x5C | ((contrast >> 4) & 0x3)); // contast High/icon/power
	lcd_send_cmd(0x6C); // follower control
	//wait_ms(300);
    //Delay();
    //delayMs(0, 300);
	WaitMs(300);

	lcd_send_cmd(0x38);//0b00111000); // function set
	lcd_send_cmd(0x0c);//0b00001100); // Display On

	lcd_send_cmd(0x01);//0b00000001); // Clear Display
	//wait_ms(2);			 // Clear Displayは追加ウェイトが必要
    //Delay();
    //delayMs(0, 2);
	WaitMs(2);


  return 0;
}

// コマンドを送信します。HD44780でいうRS=0に相当
uint8_t lcd_send_cmd(unsigned char db)
{
	return lcd_write(0x7c, 0x00, db);
}

// データを送信します。HD44780でいうRS=1に相当
uint8_t lcd_send_data(unsigned char db)
{
	return lcd_write(0x7c, 0x40, db);
}

void lcd_locate(unsigned char line, unsigned char col){
	if (line == 0){
		lcd_send_cmd(0x80 + col);	// move to 1st line
	} else {
		lcd_send_cmd(0xC0 + col);	// move to 2nd line
	}
}

// （主に）文字列を連続送信します。
uint8_t lcd_puts(unsigned char *s)
{
        uint8_t re;

	while(*s){
          re = lcd_send_data(*s++);
          if(re<0) return re;
	}
        return 0;
}

uint8_t lcd_lprintln(unsigned char line, char *s){
	lcd_locate(line, 0);
	lcd_puts((unsigned char *)s);

}

uint8_t lcd_clear()
{
        uint8_t re;

  	re = lcd_send_cmd(0x01);
        if(re) return re;

	//wait_ms(2);
    //Delay();
    //delayMs(0, 2);
        WaitMs(2);
        return 0;
}

unsigned char lcd_write(unsigned addr, unsigned char eeaddr, unsigned char dat)
{
  I2CWriteLength = 3;
  I2CReadLength = 0;
  I2CMasterBuffer[0] = addr;
  I2CMasterBuffer[1] = eeaddr;		/* address */
  I2CMasterBuffer[2] = dat;		/* Data0 */
  return !I2CEngine();
}
