/*
 * vs1011.c
 *
 *  Created on: 2016/12/17
 */

#include <stdint.h>
#include "gpio.h"
#include "ssp.h"
#include "vs1063.h"
//#include "timer32.h"
#include "string.h"
#include "mp3_11.h"

void WaitMs(uint32_t delayInMs);

void VS1063_HardwareReset(){
    uint16_t	mode;

#if defined(DEBUG)
//	DebugWriteln((char *)"VS1063_HardwareReset 1 start\r\n");
#endif

	VS1063_XRESET_H();		// XRESET
    //delay32Ms(DELAY_TIMER_NUM, 1000);
	WaitMs(1000);
    VS1063_XRESET_L();		// XRESET
    VS1063_BSYNC_H();		// BSYNC(DCS)
    VS1063_XCS_H();			// XCS
    //delay32Ms(DELAY_TIMER_NUM, 1000);
    WaitMs(1000);
    VS1063_XRESET_H();		// XRESET

	//DebugWriteln((char *)"VS1063_HardwareReset 2 start\r\n");

    while(!VS1063_DREQ()) ;
	//DebugWriteln((char *)"VS1063_HardwareReset 2A start\r\n");
    mode = SM_SDINEW_B | SM_TESTS_B;
    //mode = SM_SDINEW_B;
    VS1063_WriteSci(SCI_MODE, mode);

	//DebugWriteln((char *)"VS1063_HardwareReset 3 start\r\n");

    while(!VS1063_DREQ()) ;
    //mode = 0x8000 + (6000);     // = 0x8000 + (12000000/2000)		// VS1011
    mode = (0x8000 | CLOCKF_FREQ);     // = 0x8000 + ((12000000 - 8000000)/4000)	// VS1063
    VS1063_WriteSci(SCI_CLOCKF, mode);          // CLOCKF

	//DebugWriteln((char *)"VS1063_HardwareReset 4 start\r\n");

    if (!(Volume <= MAX_VOLUME && Volume >= MIN_VOLUME)){
        Volume = DEFAULT_VOLUME;
    }
    Volume = 0x00;
    VS1063_SetVolume(Volume);
	//DebugWriteln((char *)"VS1063_HardwareReset 5 start\r\n");
}

void VS1063_WriteSci(uint8_t addr, uint16_t val){
	uint8_t		buff[4];
	VS1063_XCS_L();
	buff[0] = 2;
	buff[1] = addr;
	buff[2] = (val >> 8);
	buff[3] = (val & 0x00FF);
	SSP_Send(SSP_VS, buff, 4);
    VS1063_XCS_H();
}

uint16_t VS1063_ReadSci(uint8_t addr){
	uint8_t		buff[4];
	uint8_t		buff2[4];
    uint16_t    val = 0;

	buff[0] = 0x03;
	buff[1] = addr;
	buff[2] = 0;
	buff[3] = 0;

	VS1063_XCS_L();
#if 1
	SSP_Send(SSP_VS, buff, 2);
	SSP_Receive(SSP_VS, buff2, 2);
#else
	buff2[0] = SSP_Exchange(SSP_VS, buff[0]);
	buff2[1] = SSP_Exchange(SSP_VS, buff[1]);
	buff2[2] = SSP_Exchange(SSP_VS, buff[2]);
	buff2[3] = SSP_Exchange(SSP_VS, buff[3]);
#endif
    VS1063_XCS_H();

	//val = SSP_Exchange(SSP_VS, 0);		// buff[0];
    //val <<= 8;
    //val |= SSP_Exchange(SSP_VS, 0);		// buff[1];
#if 1
    val = buff2[0];
    val <<= 8;
    val |= buff2[1];
#else
    val = buff2[2];
    val <<= 8;
    val |= buff2[3];
#endif

    return val;
}

uint16_t VS1063_ReadWram(uint16_t addr){
    VS1063_WriteSci(SCI_WRAMADDR, addr);
    return VS1063_ReadSci(SCI_WRAM);
}

void VS1063_SetVolume(uint16_t volume){
    uint16_t    vol;

    while(!VS1063_DREQ()) ;
    vol = (volume << 8) | volume;
    VS1063_WriteSci(SCI_VOL, vol);          // VOL
}

void VS1063_SineTest(void){
	uint8_t		buff[16];

    //delay32Ms(DELAY_TIMER_NUM, 4000);		// テストモード実行のためにはVS1063の起動後に待ち時間がすこし必要
	WaitMs(4000);

	/* テストモードシーケンス出力 */
    while(!VS1063_DREQ()) ;
	VS1063_BSYNC_L();
 	// Start Sine Test
	buff[0] = 0x53;
	buff[1] = 0xEF;
	buff[2] = 0x6E;
	buff[3] = 126;			// 5168kHz
	buff[4] = 0x00;			// 最後に送る0x00の数はVS1011とVS1063とで異なる
	buff[5] = 0x00;
	buff[6] = 0x00;
	buff[7] = 0x00;
	buff[8] = 0x00;
	buff[9] = 0x00;
	buff[10] = 0x00;
	buff[11] = 0x00;
	buff[12] = 0x00;
	buff[13] = 0x00;
	buff[14] = 0x00;
	buff[15] = 0x00;
	SSP_Send(SSP_VS, buff, 16);
	VS1063_BSYNC_H();
}

