/*
 * vs1011.h
 *
 *  Created on: 2016/12/17
 */

#ifndef VS1063_H_
#define VS1063_H_

#include <stdint.h>

#define	VS1063_BSYNC_H()		GPIOSetBitValue(0, 19, 1)
#define	VS1063_BSYNC_L()		GPIOSetBitValue(0, 19, 0)

#define	VS1063_DCS_H()			GPIOSetBitValue(0, 19, 1)
#define	VS1063_DCS_L()			GPIOSetBitValue(0, 19, 0)

#define	VS1063_XCS_H()			GPIOSetBitValue(0, 18, 1)
#define	VS1063_XCS_L()			GPIOSetBitValue(0, 18, 0)

#define VS1063_XRESET_H()		GPIOSetBitValue(1, 18, 1)
#define VS1063_XRESET_L()		GPIOSetBitValue(1, 18, 0)

#define VS1063_DREQ()			GPIOGetPinValue(0, 17)

// VS1063 register constants
#define SCI_MODE                0x00
#define SCI_STATUS              0x01
#define SCI_BASS                0x02
#define SCI_CLOCKF              0x03
#define SCI_AUDATA              0x05
#define SCI_WRAM                0x06
#define SCI_WRAMADDR            0x07
#define SCI_HDAT0               0x08
#define SCI_HDAT1               0x09
#define SCI_AIADDR              0x0A
#define SCI_VOL                 0x0B
#define SCI_AICTRL0             0x0C
#define SCI_AICTRL1             0x0D
#define SCI_AICTRL2             0x0E
#define SCI_AICTRL3             0x0F

// VS1063 SCI_MODE bits
#define SM_DIFF_B             	0x0001		// Bit:0
#define SM_LAYER12_B          	0x0002		/* VS1063, VS1053, VS1033, VS1063 */
#define SM_RESET_B            	0x0004      // Soft reset
#define SM_CANCEL_B           	0x0008		// Bit:3
#define SM_TESTS_B            	0x0020		// Bit:5
#define SM_DACT_B             	0x0100
#define SM_SDIORD_B           	0x0200		// Bit:9
#define SM_SDISHARE_B         	0x0400		// Bit:10
#define SM_SDINEW_B           	0x0800		// Bit:11
#define SM_ENCODE_B           	0x1000		// Bit:12 /* VS1063 */
#define SM_LINE1_B            	0x4000		// Bit:14 /* VS1063, VS1053 */
#define SM_CLK_RANGE_B        	0x8000		// Bit:15 /* VS1063, VS1053, VS1033 */

#define MIN_VOLUME              0x0000
#define MAX_VOLUME              0x00D0
#define DEFAULT_VOLUME          0x0020
#define STEP_VOLUME             0x0004
//#define ENCODE_BUF_SIZE			512

#define	CLOCKF_FREQ				(1000)		// (12000000 - 8000000)/4000

/* Parametric */
#define PAR_END_FILL_BYTE       0x1e06          /* VS1063, VS1053 */

/* WRAMADDR : bitrate mode / bitrate multiplier */
#define RQ_MODE_QUALITY 0x0000
#define RQ_MODE_VBR     0x4000
#define RQ_MODE_ABR     0x8000
#define RQ_MODE_CBR     0xc000
#define RQ_MULT_10      0x0000
#define RQ_MULT_100     0x1000
#define RQ_MULT_1000    0x2000
#define RQ_MULT_10000   0x3000
#define RQ_MP3_NO_BIT_RESERVOIR     0x0400      // (1<<10)

void VS1063_HardwareReset();
void VS1063_WriteSci(uint8_t addr, uint16_t val);
uint16_t VS1063_ReadSci(uint8_t addr);
uint16_t VS1063_ReadWram(uint16_t addr);
void VS1063_SetVolume(uint16_t volume);
void VS1063_SineTest(void);

#endif /* VS1063_H_ */
